/* **********Usqrt.c*****************
   Unsigned 16 bit squareroot

   This example accompanies the book
     "Embedded Microcomputer Systems: Real Time Interfacing", Brooks-Cole, copyright (c) 2000,
      Jonathan W. Valvano 7/6/99

   Interface between the TExaS simulator running a MC68HC11 EVB
      with ICC11 freeware compiler 
   TExaS Copyright 1999 by Jonathan W. Valvano 
   for more information about ICC11 
      see http://www.imagecraft.com
   You may use this file without restrictions
*/
#include "HC11.h"

unsigned int usqrt(unsigned int u) {
/* unsigned 16 bit x=sqrt(u) no overflow is possible
  Notice, this implementation is not very efficient,
  but it does demonstrate data-dependent execution speed. */
  unsigned int x;
  x=0;
  while(x*x<u) x++;
  return(x);
}

unsigned int output;
void main(void){  unsigned int i,y;
  while (1){
    for(i=1;i<10001;i=i*10){
      y=usqrt(i);
      output=y;
    }
  }
}
void resetVectors(void){
/* not really a function, 
   this function must be the very last */
  asm(" org $FFFE");
  asm(" FDB __start");
  asm(" org $FC00"); /* puts rts in a harmless place */
}
