/* ****************sci11.h********
   Simple I/O routines to serial port for the MC68HC11EVB

   This example accompanies the book
     "Embedded Microcomputer Systems: Real Time Interfacing", Brooks-Cole, copyright (c) 2000,
      Jonathan W. Valvano 7/11/99

   Interface between the TExaS simulator running a MC68HC11EVB
        and the ICC11 freeware compiler 
   TExaS Copyright 1999 by Jonathan W. Valvano 
   You may use this file without restrictions
    
 */
#define CR 13
#define LF 10
#define BS 8
#define SP 32
/*------------Initialization------------------------------------- */
void InitSCI(void);             /* Initialize 12500 bits/sec  */

/*--------------Input/Receive from serial port------------------- */
char InChar(void);              /* Reads in a character, gadfly  */
void InString(char *, unsigned int); /* Reads in a String of max length */
unsigned int InUDec(void);	/* Reads in an Unsigned 16 bit Decimal number from the SCI */
int InSDec(void);	        /* Reads in a Signed 16 bit Decimal number */
unsigned int InUHex(void);	/* Reads in an Unsigned 16 bit Hexadecimal number */
unsigned char InStatus(void);   /* Returns RDRF of Input SCI Port */

/*--------------Output/Transmit to serial port------------------- */
unsigned char OutStatus(void);  /* Returns TDRE of Output SCI Port */
void OutChar(char);             /* Output a character, gadfly  */
void OutUDec(unsigned int);     /* Output as unsigned decimal  */
void OutSDec(int);              /* Output as signed decimal  */
void OutString(char *);         /* Output a string  */
void OutUHex(unsigned int);	/* Outputs an Unsigned 16 bit Hexadecimal number */


/*----------------Utilities--------------------------------------- */
char UpCase(char);	/* Converts lower case character to upper case */

